unit UFPuntuales;

interface

uses
   UProto, Graphics, math;

   procedure FP_Negativo( const Ma : Mat3D; var Mb : Mat3D);

implementation

procedure FP_Negativo( const Ma : Mat3D; var Mb : Mat3D);
var
  x,y,nx,ny,can : integer;
begin
  nx := Ma.nc;
  ny := Ma.nr;

  Mb.nc := nx;
  Mb.nr := ny;
  SetLength(Mb.dat,nx,ny,3);

  // Aplicamos la transformacin:
  // z' = 255 - z
  // donde si tenemos el tono mnimo z = 0 -> z' = 255
  // y en caso contrario para el tono mximo z = 255 -> z' = 0
  // lo cual invierte los tonos en cada canal
  for can := 0 to 2 do
    for y := 0 to ny - 1 do
      for x := 0 to nx - 1 do
        Mb.dat[x][y][can] := 255 - Ma.dat[x][y][can];
end;

end.
